import * as ko from 'knockout';
import { Router } from './router';
import { isUndefined, isActivePath, resolveHref, traversePath } from './utils';
ko.bindingHandlers.path = {
    init: function (el, valueAccessor, allBindings, viewModel, bindingCtx) {
        var activePathCSSClass = allBindings.get('pathActiveClass') || Router.config.activePathCSSClass;
        Router.initialized.then(function () {
            var route = ko.pureComputed(function () { return traversePath(getRouter(bindingCtx), ko.unwrap(valueAccessor())); });
            ko.applyBindingsToNode(el, {
                attr: {
                    href: ko.pureComputed(function () { return resolveHref(route()); })
                },
                css: (_a = {},
                    _a[activePathCSSClass] = ko.pureComputed(function () { return isActivePath(route()); }),
                    _a)
            });
            var _a;
        });
    }
};
function getRouter(bindingCtx) {
    while (!isUndefined(bindingCtx)) {
        if (!isUndefined(bindingCtx.$router)) {
            return bindingCtx.$router;
        }
        bindingCtx = bindingCtx.$parentContext;
    }
    return Router.head;
}
//# sourceMappingURL=binding.js.map